#pragma once
#include "../states/istatemanager.h"

struct ISelectCommand {
	virtual void execute() = 0;
};

class ChangeStateCommand : public ISelectCommand {
public:
	ChangeStateCommand(IStateManager& state_manager) : m_state_manager(state_manager) {}
protected:
	IStateManager& m_state_manager;
};


class ExitCommand : public ChangeStateCommand {


};


class GameBuilderDirector {


};

class GameCommand : public ChangeStateCommand {
public:
	GameCommand(IStateManager& state_manager, std::unique_ptr< GameBuilderDirector> ptr_director) :
		ChangeStateCommand(state_manager) {}
private:
	std::unique_ptr<GameBuilderDirector> m_ptr_director;
};